/**
 * Bastion API
 * Oracle Cloud Infrastructure Bastion provides restricted and time-limited access to target resources that don't have public endpoints. Through the configuration of a bastion, you can let authorized users connect from specific IP addresses to target resources by way of Secure Shell (SSH) sessions hosted on the bastion.
 * OpenAPI spec version: 20210331
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details about a port forwarding session for a target resource.
 */
export interface CreatePortForwardingSessionTargetResourceDetails extends model.CreateSessionTargetResourceDetails {
    /**
     * The unique identifier (OCID) of the target resource (a Compute instance, for example) that the session connects to.
     */
    "targetResourceId"?: string;
    /**
     * The private IP address of the target resource that the session connects to.
     */
    "targetResourcePrivateIpAddress"?: string;
    "sessionType": string;
}
export declare namespace CreatePortForwardingSessionTargetResourceDetails {
    function getJsonObj(obj: CreatePortForwardingSessionTargetResourceDetails, isParentJsonObj?: boolean): object;
    const sessionType = "PORT_FORWARDING";
    function getDeserializedJsonObj(obj: CreatePortForwardingSessionTargetResourceDetails, isParentJsonObj?: boolean): object;
}
