/**
 * Database Management API
 * Use the Database Management API to perform tasks such as obtaining performance and resource usage metrics
for a fleet of Managed Databases or a specific Managed Database, creating Managed Database Groups, and
running a SQL job on a Managed Database or Managed Database Group.

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as AddManagedDatabaseToManagedDatabaseGroupRequest from "./add-managed-database-to-managed-database-group-request";
export import AddManagedDatabaseToManagedDatabaseGroupRequest = AddManagedDatabaseToManagedDatabaseGroupRequest.AddManagedDatabaseToManagedDatabaseGroupRequest;
import * as ChangeDatabaseParametersRequest from "./change-database-parameters-request";
export import ChangeDatabaseParametersRequest = ChangeDatabaseParametersRequest.ChangeDatabaseParametersRequest;
import * as ChangeJobCompartmentRequest from "./change-job-compartment-request";
export import ChangeJobCompartmentRequest = ChangeJobCompartmentRequest.ChangeJobCompartmentRequest;
import * as ChangeManagedDatabaseGroupCompartmentRequest from "./change-managed-database-group-compartment-request";
export import ChangeManagedDatabaseGroupCompartmentRequest = ChangeManagedDatabaseGroupCompartmentRequest.ChangeManagedDatabaseGroupCompartmentRequest;
import * as CreateJobRequest from "./create-job-request";
export import CreateJobRequest = CreateJobRequest.CreateJobRequest;
import * as CreateManagedDatabaseGroupRequest from "./create-managed-database-group-request";
export import CreateManagedDatabaseGroupRequest = CreateManagedDatabaseGroupRequest.CreateManagedDatabaseGroupRequest;
import * as DeleteJobRequest from "./delete-job-request";
export import DeleteJobRequest = DeleteJobRequest.DeleteJobRequest;
import * as DeleteManagedDatabaseGroupRequest from "./delete-managed-database-group-request";
export import DeleteManagedDatabaseGroupRequest = DeleteManagedDatabaseGroupRequest.DeleteManagedDatabaseGroupRequest;
import * as GetAwrDbReportRequest from "./get-awr-db-report-request";
export import GetAwrDbReportRequest = GetAwrDbReportRequest.GetAwrDbReportRequest;
import * as GetAwrDbSqlReportRequest from "./get-awr-db-sql-report-request";
export import GetAwrDbSqlReportRequest = GetAwrDbSqlReportRequest.GetAwrDbSqlReportRequest;
import * as GetClusterCacheMetricRequest from "./get-cluster-cache-metric-request";
export import GetClusterCacheMetricRequest = GetClusterCacheMetricRequest.GetClusterCacheMetricRequest;
import * as GetDatabaseFleetHealthMetricsRequest from "./get-database-fleet-health-metrics-request";
export import GetDatabaseFleetHealthMetricsRequest = GetDatabaseFleetHealthMetricsRequest.GetDatabaseFleetHealthMetricsRequest;
import * as GetDatabaseHomeMetricsRequest from "./get-database-home-metrics-request";
export import GetDatabaseHomeMetricsRequest = GetDatabaseHomeMetricsRequest.GetDatabaseHomeMetricsRequest;
import * as GetJobRequest from "./get-job-request";
export import GetJobRequest = GetJobRequest.GetJobRequest;
import * as GetJobExecutionRequest from "./get-job-execution-request";
export import GetJobExecutionRequest = GetJobExecutionRequest.GetJobExecutionRequest;
import * as GetJobRunRequest from "./get-job-run-request";
export import GetJobRunRequest = GetJobRunRequest.GetJobRunRequest;
import * as GetManagedDatabaseRequest from "./get-managed-database-request";
export import GetManagedDatabaseRequest = GetManagedDatabaseRequest.GetManagedDatabaseRequest;
import * as GetManagedDatabaseGroupRequest from "./get-managed-database-group-request";
export import GetManagedDatabaseGroupRequest = GetManagedDatabaseGroupRequest.GetManagedDatabaseGroupRequest;
import * as ListAwrDbSnapshotsRequest from "./list-awr-db-snapshots-request";
export import ListAwrDbSnapshotsRequest = ListAwrDbSnapshotsRequest.ListAwrDbSnapshotsRequest;
import * as ListAwrDbsRequest from "./list-awr-dbs-request";
export import ListAwrDbsRequest = ListAwrDbsRequest.ListAwrDbsRequest;
import * as ListDatabaseParametersRequest from "./list-database-parameters-request";
export import ListDatabaseParametersRequest = ListDatabaseParametersRequest.ListDatabaseParametersRequest;
import * as ListJobExecutionsRequest from "./list-job-executions-request";
export import ListJobExecutionsRequest = ListJobExecutionsRequest.ListJobExecutionsRequest;
import * as ListJobRunsRequest from "./list-job-runs-request";
export import ListJobRunsRequest = ListJobRunsRequest.ListJobRunsRequest;
import * as ListJobsRequest from "./list-jobs-request";
export import ListJobsRequest = ListJobsRequest.ListJobsRequest;
import * as ListManagedDatabaseGroupsRequest from "./list-managed-database-groups-request";
export import ListManagedDatabaseGroupsRequest = ListManagedDatabaseGroupsRequest.ListManagedDatabaseGroupsRequest;
import * as ListManagedDatabasesRequest from "./list-managed-databases-request";
export import ListManagedDatabasesRequest = ListManagedDatabasesRequest.ListManagedDatabasesRequest;
import * as ListTablespacesRequest from "./list-tablespaces-request";
export import ListTablespacesRequest = ListTablespacesRequest.ListTablespacesRequest;
import * as RemoveManagedDatabaseFromManagedDatabaseGroupRequest from "./remove-managed-database-from-managed-database-group-request";
export import RemoveManagedDatabaseFromManagedDatabaseGroupRequest = RemoveManagedDatabaseFromManagedDatabaseGroupRequest.RemoveManagedDatabaseFromManagedDatabaseGroupRequest;
import * as ResetDatabaseParametersRequest from "./reset-database-parameters-request";
export import ResetDatabaseParametersRequest = ResetDatabaseParametersRequest.ResetDatabaseParametersRequest;
import * as SummarizeAwrDbCpuUsagesRequest from "./summarize-awr-db-cpu-usages-request";
export import SummarizeAwrDbCpuUsagesRequest = SummarizeAwrDbCpuUsagesRequest.SummarizeAwrDbCpuUsagesRequest;
import * as SummarizeAwrDbMetricsRequest from "./summarize-awr-db-metrics-request";
export import SummarizeAwrDbMetricsRequest = SummarizeAwrDbMetricsRequest.SummarizeAwrDbMetricsRequest;
import * as SummarizeAwrDbParameterChangesRequest from "./summarize-awr-db-parameter-changes-request";
export import SummarizeAwrDbParameterChangesRequest = SummarizeAwrDbParameterChangesRequest.SummarizeAwrDbParameterChangesRequest;
import * as SummarizeAwrDbParametersRequest from "./summarize-awr-db-parameters-request";
export import SummarizeAwrDbParametersRequest = SummarizeAwrDbParametersRequest.SummarizeAwrDbParametersRequest;
import * as SummarizeAwrDbSnapshotRangesRequest from "./summarize-awr-db-snapshot-ranges-request";
export import SummarizeAwrDbSnapshotRangesRequest = SummarizeAwrDbSnapshotRangesRequest.SummarizeAwrDbSnapshotRangesRequest;
import * as SummarizeAwrDbSysstatsRequest from "./summarize-awr-db-sysstats-request";
export import SummarizeAwrDbSysstatsRequest = SummarizeAwrDbSysstatsRequest.SummarizeAwrDbSysstatsRequest;
import * as SummarizeAwrDbTopWaitEventsRequest from "./summarize-awr-db-top-wait-events-request";
export import SummarizeAwrDbTopWaitEventsRequest = SummarizeAwrDbTopWaitEventsRequest.SummarizeAwrDbTopWaitEventsRequest;
import * as SummarizeAwrDbWaitEventBucketsRequest from "./summarize-awr-db-wait-event-buckets-request";
export import SummarizeAwrDbWaitEventBucketsRequest = SummarizeAwrDbWaitEventBucketsRequest.SummarizeAwrDbWaitEventBucketsRequest;
import * as SummarizeAwrDbWaitEventsRequest from "./summarize-awr-db-wait-events-request";
export import SummarizeAwrDbWaitEventsRequest = SummarizeAwrDbWaitEventsRequest.SummarizeAwrDbWaitEventsRequest;
import * as UpdateManagedDatabaseGroupRequest from "./update-managed-database-group-request";
export import UpdateManagedDatabaseGroupRequest = UpdateManagedDatabaseGroupRequest.UpdateManagedDatabaseGroupRequest;
