/**
 * DevOps API
 * Use the DevOps APIs to create a DevOps project to group the pipelines,  add reference to target deployment environments, add artifacts to deploy,  and create deployment pipelines needed to deploy your software.
 * OpenAPI spec version: 20210630
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Specifies the instance group rolling deployment stage.
 */
export interface ComputeInstanceGroupDeployStageSummary extends model.DeployStageSummary {
    /**
     * A compute instance group environment OCID for rolling deployment.
     */
    "computeInstanceGroupDeployEnvironmentId": string;
    /**
     * The OCID of the artifact that contains the deployment specification.
     */
    "deploymentSpecDeployArtifactId": string;
    /**
     * Additional file artifact OCIDs.
     */
    "deployArtifactIds"?: Array<string>;
    "rolloutPolicy": model.ComputeInstanceGroupLinearRolloutPolicyByPercentage | model.ComputeInstanceGroupLinearRolloutPolicyByCount;
    "rollbackPolicy"?: model.NoDeployStageRollbackPolicy | model.AutomatedDeployStageRollbackPolicy;
    "failurePolicy"?: model.ComputeInstanceGroupFailurePolicyByPercentage | model.ComputeInstanceGroupFailurePolicyByCount;
    "loadBalancerConfig"?: model.LoadBalancerConfig;
    "deployStageType": string;
}
export declare namespace ComputeInstanceGroupDeployStageSummary {
    function getJsonObj(obj: ComputeInstanceGroupDeployStageSummary, isParentJsonObj?: boolean): object;
    const deployStageType = "COMPUTE_INSTANCE_GROUP_ROLLING_DEPLOYMENT";
    function getDeserializedJsonObj(obj: ComputeInstanceGroupDeployStageSummary, isParentJsonObj?: boolean): object;
}
