/**
 * Cloud Advisor API
 * APIs for managing Cloud Advisor. Cloud Advisor provides recommendations that help you maximize cost savings and improve the security posture of your tenancy.
 * OpenAPI spec version: 20200606
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2021, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The metadata associated with the strategy parameter.
 *
 */
export interface StrategyParameter {
    /**
     * The name of the strategy parameter.
     */
    "name": string;
    /**
     * The type of strategy parameter.
     */
    "type": model.StrategyParameterType;
    /**
     * Text describing the strategy parameter.
     */
    "description": string;
    /**
     * Whether this parameter is required.
     */
    "isRequired": boolean;
    /**
     * A default value used for the strategy parameter.
     */
    "defaultValue"?: any;
    /**
     * The list of possible values used for these strategy parameters.
     */
    "possibleValues"?: Array<any>;
}
export declare namespace StrategyParameter {
    function getJsonObj(obj: StrategyParameter): object;
    function getDeserializedJsonObj(obj: StrategyParameter): object;
}
